LeetCode 1679. Max Number of K-Sum Pairs

Question

You are given an integer array nums and an integer k.

In one operation, you can pick two numbers from the array whose sum equals k and remove them from the array.

Return the maximum number of operations you can perform on the array.

Example 1:

1
2
3
4
5
6
Input: nums = [1,2,3,4], k = 5
Output: 2
Explanation: Starting with nums = [1,2,3,4]:
- Remove numbers 1 and 4, then nums = [2,3]
- Remove numbers 2 and 3, then nums = []
There are no more pairs that sum up to 5, hence a total of 2 operations.

Example 2:

1
2
3
4
5
Input: nums = [3,1,3,4,3], k = 6
Output: 1
Explanation: Starting with nums = [3,1,3,4,3]:
- Remove the first two 3's, then nums = [1,4,3]
There are no more pairs that sum up to 6, hence a total of 1 operation.

Constraints:

  • 1 <= nums.length <= 105
  • 1 <= nums[i] <= 109
  • 1 <= k <= 109

Source: https://leetcode.com/problems/max-number-of-k-sum-pairs/

Solution

Similar to the hashmap solution of LeetCode 1. Two Sum.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
public int maxOperations(int[] nums, int k) {
int count = 0;
// num value -> num count
Map<Integer, Integer> map = new HashMap<>();
// if qualified, i is always the bigger index in a pair
for (int i = 0; i < nums.length; i++) {
int n = nums[i];
if (map.containsKey(k - n)) {
count++;
map.put(k - n, map.get(k - n) - 1);
if (map.get(k - n) == 0) {
map.remove(k - n);
}
} else {
map.put(n, map.getOrDefault(n, 0) + 1);
}
}
return count;
}
Author

Weihao Ye

Posted on

2022-03-10

Updated on

2022-03-10

Licensed under